



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>行为模式--代理Proxy模式（Java）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">行为模式--代理Proxy模式（Java）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 05:25:59 </span>
						</div>
										<div class="post-content">
											
		<p>代理（AOP切面的雏形）：</p>
<p>题记：顾名思义就是将某件事，某个东西的使用权进行为让授权转移。代理相当于中介（不同于中介者模式），在原本操作的类之间添加了一个桥梁。但代理不能去修改原有目标。比如：一个人要买 &nbsp; &nbsp; &nbsp; 房，让中介帮忙给看个房，但中介不能将原有看房这件事变更为看车。他可以对看房提出各种要求和咨询。</p>
<p>回到程序的角度，调用者将调用某些共性类的处理交由代理类处理，代理类根据调用者的要求即满足什么情况可以调用，什么情况不能调用，（卖房者委托中介100万以上卖，100万以下不卖）对处理做前后的包装，但是代理类不能去改变被调用类的内部处理（可口可乐中国区可修改可口可乐包装，但不能在没授权情况下去更改可口可乐饮料）。</p>
<p>1.静态代理</p>
<p>2.动态代理</p>
<p>1.静态代理：对指定接口类做代理，通过对执行方法前后做处理，来实现代理的作用。因对指定接口类，因此可做某些特定类的特殊处理。</p>
<div>
<div>
<pre class="prettyprint linenums"> /**<br />
  * 静态代理，也被称为decate模式<br />
  *<br />
  * @author DennyZhao<br />
  * @date 2017年6月13日<br />
  * @version 1.0<br />
  */<br />
 public class AnimalProxyFactory implements AnimalFactory {<br />
     /**<br />
      * 序列号<br />
      */<br />
     private static final long serialVersionUID = -3421761900236678842L;

     private AnimalFactory animal;

     public AnimalProxyFactory(AnimalFactory animal){<br />
         this.animal = animal;<br />
     }<br />
     @Override<br />
     public int getLegs() {<br />
         System.out.println("before....action");<br />
         int legs = animal.getLegs();<br />
         System.out.println("after....action");<br />
         return legs;<br />
     }

 }</pre>
</div>
</div>
<p>测试Main：</p>
<p>　　// 静态代理<br />		　　Rabit rabit = new Rabit();<br />		　　AnimalProxyFactory proxyFactory = new AnimalProxyFactory(rabit);<br />		　　System.out.println(proxyFactory.getLegs());</p>
<p>运行结果：</p>
<p>　　&gt;&gt;&gt;before....action<br />　　&gt;&gt;&gt;after....action<br />　　&gt;&gt;&gt;4</p>
<p>2.动态代理：动态代理通过Proxy类创建代理，通过InvokationHandler去调用方法。</p>
<div>
<div>
<pre class="prettyprint linenums"> package pattern.creation.factory;

 import java.io.FileInputStream;<br />
 import java.io.FileNotFoundException;<br />
 import java.io.IOException;<br />
 import java.lang.reflect.Proxy;<br />
 import java.util.Properties;

 /**<br />
  * 动态代理模式<br />
  *<br />
  * @author DennyZhao<br />
  * @date 2017年6月13日<br />
  * @version 1.0<br />
  */<br />
 public class ProxyFactory {<br />
     private static final String CLASS_NAME_PATH = "pattern/classname.properties";<br />
     @SuppressWarnings("unchecked")<br />
     public static &lt;T&gt; T getInstance(String name) throws IllegalArgumentException, InstantiationException, IllegalAccessException{<br />
         String className = getClassName(name);<br />
         T result = null;<br />
         try {<br />
             Class clazz = Class.forName(className);<br />
             result = (T)Proxy.newProxyInstance(clazz.getClassLoader(), clazz.getInterfaces(), new MyInvocationHandler(clazz.newInstance()));<br />
         } catch (ClassNotFoundException e) {<br />
             e.printStackTrace();<br />
         }<br />
         return result;<br />
     }

     /**<br />
      * 获取类名称<br />
      * @return<br />
      */<br />
     private static String getClassName(String name) {<br />
         Properties pro = new Properties();<br />
         try {<br />
             String url = ProxyFactory.class.getClassLoader().getResource("").getPath() + CLASS_NAME_PATH;<br />
             pro.load(new FileInputStream(url));<br />
         } catch (FileNotFoundException e) {<br />
             e.printStackTrace();<br />
         } catch (IOException e) {<br />
             e.printStackTrace();<br />
         }<br />
         return (String)pro.get(name);<br />
     }<br />
 }</pre>
</div>
</div>
<p>注意* ： 代理面向的是接口，因此委托的类都需要实现指定的接口。</p>
<p>　　　　　　result = (T)Proxy.newProxyInstance(clazz.getClassLoader(), clazz.getInterfaces(), new MyInvocationHandler(clazz.newInstance()));</p>
<p>　　　　　　clazz.getInterfaces()：如果一个clazz实现多个接口，此处要传入接口Class。</p>
<p>　　　　　　MyInvocationHandler 实现 InvocationHandler接口，里面要实现一个invoke方法，在这个invoke方法中填写处理。</p>
<div>MyInvocationHandler&nbsp;</div>
<p>/<em>/ 可通过放射机制，来处理特殊类的特殊请求。</em></p>
<p>测试Main:</p>
<p>// 动态代理，AOP切面的雏形做法<br />		AnimalFactory sheep = ProxyFactory.getInstance("sheep");<br />		sheep.getLegs();</p>
<p>// 动态代理，AOP切面的做法<br />		PlantFactory plum = ProxyFactory.getInstance("plum");<br />		plum.getColor();</p>
<p>// 动态代理，AOP切面的做法<br />		AnimalFactory rabit0 = ProxyFactory.getInstance("rabit");<br />		rabit0.getLegs();</p>
<p>结果：</p>
<p>before-------<br />sheep has 4 legs....<br />after-------<br />before-------<br /> plum green  purple....<br />after-------<br />before-------<br />兔子是特殊的<br />after-------</p>
<p>深入理解静态代理和动态代理：</p>
<p>静态代理：需要代理类和实体类拥有同一个接口，这样才能保证口径一致，即代理商不能随意改变原实体类的行为。在代理类中将实体类注入进去，实现代理类和实体类的关联。这样在调用代理类时，会找到对应的实体类触发其行为，在调用前后又可以写入其它信息比如轨迹日志。</p>
<div>
<pre class="prettyprint linenums">// 静态代理<br />
IAnimal animal = new Sheep();<br />
IAnimal proxy = new ProxyAnimal(animal);<br />
System.out.println(proxy.getName());</pre>
</div>
<p>jdk动态代理：动态代理的本质和静态代理是一致的。只不过动态代理是因为事前根本不知道要去代理谁，且原静态代理类，如果要实现代理需要写相同的实体类的相关接口，和好多代理类，扩展维护很麻烦。因此就采用一种动态代理。 通过定义一个类 实现 InvocationHandler接口的方法，即统一的代理行为，之后的所有代理信息都会进入到这个方法中，包括目标方法和目标参数。然后再由一个Proxy静态类，去在运行时创建一个类class $Proxy0，这个类会由ProxyGenerate根据传入的所有的接口，通过反射获取他们的方法，实现他们的方法，同时把Invocationhandler注入到这个类中，生成类似我们静态代理的临时类。坦白的说只是把我们自己写代理的这个过程交给机器来编写实现。</p>
<div>
<pre class="prettyprint linenums"> InvocationHandler invocation = new AnimalInvocation(new Sheep());<br />
        // 动态代理<br />
        Object animals = Proxy.newProxyInstance(invocation.getClass().getClassLoader(), new Class[]{IAnimal.class, IPlant.class}, invocation);<br />
        IPlant plant = (IPlant) animals;<br />
        IAnimal animal = (IAnimal) animals;</pre>
</div>
<pre class="prettyprint linenums">在这个 invocation中我们可以传入我们的实体对象（构造带参的构造器），也可以不传递通过rpc或者远端http请求获取Feign。</pre>
<div>
<pre class="prettyprint linenums">public class AnimalInvocation implements InvocationHandler {

    private Object obj;

    /**<br />
     * 创建代理对象<br />
     * @param proxy<br />
     * @param method<br />
     * @param args<br />
     * @return<br />
     * @throws Throwable<br />
     */<br />
    @Override<br />
    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {<br />
        System.out.println(proxy.getClass());<br />
        // rcp调用远端接口处理数据，返回   method， obj ，args<br />
        return "其实我什么都不是";<br />
        //return method.invoke(obj, args);<br />
    }</pre>
</div>
<p>spring有个AOP的切面使用的也是反向代理，只不过他的实现机理和我们JDK的内部的有些不一样。spring用的是cJlib,通过创建一个子类继承当前的service类。在调用中通过super来调用父类的方法实现代理。祥见&nbsp; spring-AOP切面</p>
<p>因service中可以不定义接口，yi'ni'c</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r1med8.html">unity行为树制作AI简单例子（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7p2g9.html">mysql怎么导入大文件的sql文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd71m7q.html">远离腰痛的好方法&amp;mdash&semi;&amp;mdash&semi;如何锻炼腰背部肌肉？</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypv2dq.html">&lbrack;Effective JavaScript 笔记&rsqb;第36条：只将实例状态存储在实例对象中</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnjoo0q.html">iOS网络传输Delegate不被触发的本质原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w3y4lq.html">Android问题-新电脑新系统WIN764位上安装简版本的XE8提示&OpenCurlyDoubleQuote;Unit not found&colon; &amp;&num;39&semi;System&amp;&num;39&semi;&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w4jgwq.html">POSTGRESQL小玩</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jx1738.html">apache-tomcat-7&period;0&period;70无法进入Manager管理App项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pz12n8.html">poj2524 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmg7pq.html">Git使用教程&comma;最详细，最傻瓜，最浅显，真正手把手教</a>
		</li>
						<li><a href="https://www.batexi.com/a/950631e8.html">Electron桌面应用打包流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjmy69.html">CentOS5&period;5 - lnmp环境安装与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o141jlq.html">2018-08-13 Head First OO分析设计一书略读与例子中文化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1d6xpq.html">Apache 开启压缩传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4wwke9.html">Windows 10 更改系统文字大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emwm5k9.html">day08&lpar;File类 ，字节流&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7evvoe9.html">mac 开发环境安装使用 记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnlle4q.html">PHP获得真实客户端的真实时用到的IP REMOTE&lowbar;ADDR，HTTP&lowbar;CLIENT&lowbar;IP，HTTP&lowbar;X&lowbar;FORWARDED&lowbar;FOR</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ergwe9.html">Python学习---抽屉框架分析&lbrack;小评论分析&rsqb;0315</a>
		</li>
						<li><a href="https://www.batexi.com/a/902zjroq.html">IIS7&period;5 HTTP 错误500&period;19-Internal Server Error 无法访问请求的页面，因为该页的相关配置数据无效</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wmnorq.html">offse家族属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd7e5e9.html">QLExpress 规则引擎使用介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25p26oq.html">i&plus;&plus; 和 &plus;&plus;i的字节码指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwlg778.html">关于string&period;Template的简单介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjogrl9.html">github&lowbar;地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjozrl9.html">ViewPager系列之 仿魅族应用的广告BannerView</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ok0dk8.html">sklearn不同数量的训练集在测试集上的表现的曲线刻画</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1m265q.html">Delphi 常用语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv3ep38.html">BOM跟DOM的区别和关联</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv3e2k8.html">JavaScript基础知识点学习记录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
